/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.calculo_fondo;

import danielcortes.xyz.data.SQLiteConnectionHolder;
import danielcortes.xyz.models.caja.Caja;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class SQLiteCalculoFondoDAO extends CalculoFondoDAO {
    public SQLiteCalculoFondoDAO() {
        this.connectionHolder = new SQLiteConnectionHolder();
    }

    @Override
    public List<CalculoFondo> findAll() {
        List<CalculoFondo> calculoFondoList = new ArrayList<>();
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from calculo_fondo");
            ResultSet rs = ps.executeQuery();

            calculoFondoList = this.cajasFromResultSet(rs);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return calculoFondoList;
    }
    @Override
    public List<CalculoFondo> findByCaja(Caja caja) {
        List<CalculoFondo> calculoFondoList = new ArrayList<>();
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from calculo_fondo where caja_id = ?");
            ps.setInt(1, caja.getId());

            ResultSet rs = ps.executeQuery();

            calculoFondoList = this.cajasFromResultSet(rs);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return calculoFondoList;
    }

    @Override
    public CalculoFondo findById(int id) {
        CalculoFondo calculoFondo = null;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from calculo_fondo where id = ?");
            ps.setInt(1, id);
            ResultSet rs = ps.executeQuery();

            calculoFondo = this.cajasFromResultSet(rs).get(0);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return calculoFondo;
    }

    @Override
    public boolean insertCalculoFondo(CalculoFondo calculoFondo) {
        int updates;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("insert into calculo_fondo (valor, descripcion, caja_id) values (?, ?, ?)");
            ps.setInt(1, calculoFondo.getValor());
            ps.setString(2, calculoFondo.getDescripcion());
            ps.setInt(3, calculoFondo.getCaja().getId());

            updates = ps.executeUpdate();
            ps.close();

            ps = conn.prepareStatement("select last_insert_rowid()");
            ResultSet rs = ps.executeQuery();
            rs.next();
            calculoFondo.setId(rs.getInt(1));

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean updateCalculoFondo(CalculoFondo calculoFondo) {
        int updates;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("update calculo_fondo set valor = ?, descripcion = ?, caja_id = ?  where id = ?");
            ps.setInt(1, calculoFondo.getValor());
            ps.setString(2, calculoFondo.getDescripcion());
            ps.setInt(3, calculoFondo.getCaja().getId());
            ps.setInt(4, calculoFondo.getId());

            updates = ps.executeUpdate();

            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean deleteCalculoFondo(CalculoFondo calculoFondo) {
        int updates;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("delete from calculo_fondo where id = ?");
            ps.setInt(1, calculoFondo.getId());

            updates = ps.executeUpdate();

            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
            return false;
        }
        return updates > 0;
    }

    @Override
    public int getTotalCalculoFondo(Caja caja) {
        int sum = 0;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select sum(valor) from calculo_fondo where caja_id = ?");
            ps.setInt(1, caja.getId());

            ResultSet rs = ps.executeQuery();
            rs.next();
            sum = rs.getInt(1);

            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return sum;
    }
}
